/*-
 * Copyright (C)2008 @BABOLO http://www.babolo.ru/
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 *  OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef lint
static const char copyright[] = "\
@(#)Copyright (C)2008 @BABOLO http://www.babolo.ru/\n\
@(#)All rights reserved.\n";
static const char rcsid[] = "$Id: opt.c,v 1.2 2008/09/18 05:47:18 babolo Exp $";
#endif /* not lint */

#include <sys/types.h>
#include <sysexits.h>
#include <stdlib.h>
#include <limits.h>
#include <stdio.h>
#include <errno.h>
#include <babolo/BLINflag.h>
#include "../parser.h"

int
main(int argc, char **argv) {
    u_int32_t flags = Bpars_NONU | Bpars_ESYM | Bpars_EPRM;
    babolo_opt *opt;
    babolo_parm *bp;
    int c, i;
    u_char *s;

    opt = NULL;
    if  (!!(s = getenv("INIT_FLAGS"))) {
        flags = strtoul(s, NULL, 0);
    }
    if  (!!babolo_openopt(flags, &opt, argc, argv, "a:b:f:vDR:")) {
        ifBLIN_QV1(flags) warn("openopt");
        exit(EX_SOFTWARE);
    }
    if  (flags & BLIN_VER8) babolo_dumpopt(opt);
    for (i = 0;; i++) {
        switch ((c = babolo_getopt(&opt))) {
        case 0:                                     break;
        case -1: printf("ERR %d\n", errno);         break;
        case 'v': BLIN_VERBOSE(flags);              break;
        case 'R':
            s = babolo_getoptarg(&opt, 0);
            if  (!!s) {
                bp = babolo_getparm(flags & Bpars_NOEN, &s, "", 0);
                babolo_openopt(flags & ~Bpars_NONU, &opt, bp->argc, (char **)bp->argv, NULL);
                if  (flags & BLIN_VER8) babolo_dumpopt(opt);
                break;
            }
        case 'f':
            s = babolo_getoptarg(&opt, 0);
            if  (!!s) flags = strtoul(s, NULL, 0);
        default:
            if  (babolo_getoptarg(&opt, 0)) printf(" %c=%s~\n", c, babolo_getoptarg(&opt, 0));
              else printf(" %c NULL\n", c);
        }
        if  (c == 0) break;
    }
    for (i = 0; (s = babolo_getarg(&opt)); i++) {
        printf("%d=%s~\n", i, s);
    }
    if  (flags & BLIN_VER8) babolo_dumpopt(opt);
    babolo_closeopt(&opt);
    exit(0);
}
